; Changed menu entry

(define (hello-world  inFont inFontSize inTextColor inImageSize inBgColor)
   (set! img (car (gimp-image-new inImageSize (/ inImageSize 2) RGB)))    ; create new image in Gimp
   (set! layer (car (gimp-layer-new img inImageSize (/ inImageSize 2) RGB "layer 1" 100
NORMAL)))                                                                                            ; create a new layer

   (gimp-image-undo-disable img)                                                              ; disable undo for following steps to conserve memory
   (gimp-image-add-layer img layer 0)                                                        ; insert the new layer into stack
   (gimp-palette-set-background inBgColor)                                              ; sets the background palette color to the desired color
   (gimp-edit-fill layer 1)                                                                            ; fills the new layer with background color

   (gimp-palette-set-foreground inTextColor)                                             ; now set foreground palette color for use in text
   (gimp-text-fontname img -1 0 0 " Hello World" 0 TRUE  inFontSize PIXELS inFont)      ; create Hello World  text using desired font, size

   (gimp-display-new img)                                                                         ; show the image to the world
   (gimp-image-undo-enable img)                                                              ; gimp undo now enabled
)

   (script-fu-register "hello-world"
      "<Toolbox>/Xtns/Script-Fu/Test/Hello World..."
      "Writes the minimalist Hello World Message"
      "lasm"
      "lasm"
      "2002"
      ""
      SF-FONT       _"Font"                   "-*-Charter-*-r-*-*-24-*-*-*-p-*-*-*"   ; Text Font for Hello World
      SF-ADJUSTMENT _"Font Size (pixels)"     '(45 2 1000 1 10 0 1)                  ; Font size
      SF-COLOR      _"Text Color"             '(0 0 0)                                                ; Color of Text to display
      SF-VALUE "Image Length" "300"                                                                  ; length of image rectangle
      SF-COLOR "Background Color" '(255 127 0)                                               ; background color of image box
   )
