;; tile-two-files.scm -*-scheme-*-
;; "Tile Two Files..."  Script-Fu script, aka Tile and Stitch.  

;; Requires tile-two-images.scm

;; This approach is not recommended.  
;; Opening files directly from a script is cumbersome, 
;; and the better file chooser (with preview) is unavailable.  

;; I wrote this script because I hoped it might be useful later 
;; for batch joining files at the command line

;; TODO Fix the stock "..." button label.  Should be "Browse..." 
  
(define (script-fu-tile-two-files file-one file-two layout)  
    (let* (
        ;; got file names (file-one, file-two) get images (image-one, image-two)
        (image-one (car (gimp-file-load 1 file-one file-one)))
        (image-two (car (gimp-file-load 1 file-two file-two)))

        (image -1)
        (drawable -1)
        )
        (script-fu-tile-two-images image drawable image-one image-two layout)  
    ) 
)

(script-fu-register "script-fu-tile-two-files"
    _"<Toolbox>/Xtns/Script-Fu/Tile Two Files..."
    "Tiles Two Images directly from Files using specified layout.   

SEE ALSO:
Tile Two Images.  
This script requires the 'Tile Two Image' script so you must already have it.  
It tiles using two already open images.  " 
    "Alan Horkan.  "
    "Alan Horkan.  Copyright 2004, All Rights Reserved.  "
    "April 2004"
    "" 

    SF-FILENAME _"Image 1" "" 
    SF-FILENAME _"Image 2" "" 
    SF-OPTION _"Layout  " '(
;; 50 character label, force widget to be wider because it looks ugly otherwise
            _"None                                              "   
            _"Up                                                " ; up/above  
            _"Down                                              " ; down/below
            _"Left                                              " ; beside left 
            _"Right                                             ") ; beside right
)
