;;;
;;; draw-box.scm
;;;
;;;
;;;  Arch. Giuseppe Conte <http://space.tin.it/edicola/lwcon/>
;;;
;;;  Raymond Ostertag 2004/09 changed menu entry

;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-draw-box inImage inLayer
				    inXorig inYorig
				    inWidth inHeight)

  (gimp-rect-select inImage 
		    inXorig inYorig
		    inWidth inHeight
		    REPLACE
		    FALSE		; No feathering
		    0)
  (gimp-edit-fill inLayer 0)		    

  (gimp-displays-flush)
)

(script-fu-register
 "script-fu-draw-box"
 _"<Image>/Script-Fu/Geometry/Draw Box..."
"Seleziona e riempie con il colore di primo piano attivo la regione rettangolare indicata. X ed Y indicano le coordinate dell'angolo in alto a sinistra, mentre width ed height sono le dimensioni dei suoi lati."
 "Arch. Giuseppe Conte"
 "2002, Giuseppe Conte"
 "06 Maggio 2002"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X origin" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y origin" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Width" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Height" '(0 0 9999 1 10 0 1)
)
