;;; draw-random-point.scm
;;;
;;;  Arch. Giuseppe Conte <http://space.tin.it/edicola/lwcon/>
;;;
;;;  Raymond Ostertag 2004/09 changed menu entry

;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-draw-random-point inImage inLayer randpoint )

		(set! owidth (car (gimp-image-width inImage )))
	        (set! oheight (car (gimp-image-height inImage )))

		(set! npoint 4)
		(set! gcount 0)
		
  (while (<= gcount randpoint) 		

	(let* (	(segment (cons-array 4 'double))  
		(xa (rand owidth ))
		(ya (rand oheight ))	
	     )				
  	
  		(aset segment 0 (* 1 xa))
  		(aset segment 1 (* 1 ya))
  		(aset segment 2 (* 1 xa))
  		(aset segment 3 (* 1 ya))
  
		(gimp-paintbrush-default inLayer npoint segment )
		
		(set! gcount (+ gcount 1))
   );end while
   			
  	  (gimp-displays-flush)
       );let
	
) ;;def


(script-fu-register
 "script-fu-draw-random-point"
 _"<Image>/Script-Fu/Geometry/Draw random Points..."
 "Draw the number specified of random points."
 "Arch. Giuseppe Conte <http://space.tin.it/edicola/lwcon/>"
 "2002, Giuseppe Conte"
 "10 Luglio 2002 - Florence - Italy"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "Random Points" '(10 0 9999 1 10 0 1)

)
