; GIMP Paste to new layer
; Copyright (c) 2005 Jonathan Stipe
; JonStipe@prodigy.net

(define (script-fu-paste-to-new-layer img
			    drawable)
  (gimp-image-undo-group-start img)
  (let* ((draw (car (gimp-image-get-active-drawable img))))
    (if (not (= (car (gimp-drawable-is-layer draw)) 0))
      (gimp-floating-sel-to-layer (car (gimp-edit-paste draw 1)))
      (if (not (= (car (gimp-drawable-is-layer-mask draw)) 0))
        (gimp-floating-sel-to-layer (car (gimp-edit-paste (car (gimp-image-get-active-layer img)) 1)))
        (if (not (= (car (gimp-drawable-is-channel draw)) 0))
          (gimp-floating-sel-to-layer (car (gimp-edit-paste (aref (cadr (gimp-image-get-layers img)) 0) 1)))
        )
      )
    )
  )
  (gimp-displays-flush)
  (gimp-image-undo-group-end img)
)

(script-fu-register "script-fu-paste-to-new-layer"
		    _"<Image>/Edit/Paste to new _layer"
		    "Pastes to a new layer."
		    "Jonathan Stipe <JonStipe@prodigy.net>"
		    "Jonathan Stipe"
		    "February 2005"
		    ""
		    SF-IMAGE "Image" 0
		    SF-DRAWABLE "Drawable" 0)