(define (script-fu-contrast-mask image
                                 drawable
                                 blur-level
                                 mask-opacity)

       (gimp-undo-push-group-start image)

       ; Create new layer and add to the image
       ;(set! new-bg-layer (car (gimp-layer-copy drawable 1)))
       ;(gimp-image-add-layer image new-bg-layer -1)
       ;(gimp-layer-set-name cmask-layer "Background Copy")

       ; Create new layer and add to the image
       (set! cmask-layer (car (gimp-layer-copy drawable 1)))
       (gimp-image-add-layer image cmask-layer -1)
       (gimp-layer-set-name cmask-layer "Contrast Mask")

       ; desat, negative, blur, select opacity, set layer mode
       (gimp-desaturate cmask-layer)
       (gimp-invert cmask-layer)
       (plug-in-gauss-iir 1 image cmask-layer blur-level 1 1)
       (gimp-layer-set-opacity cmask-layer mask-opacity)
       (gimp-layer-set-mode cmask-layer OVERLAY)


       ; Cleanup
       (gimp-undo-push-group-end image)
       (gimp-displays-flush))

(script-fu-register "script-fu-contrast-mask"
                    _"<Image>/Script-Fu/Alchemy/Contrast Mask..."
                    "Create a Contrast Mask Layer"
                    "Jeff Stephens jeff@tautologous.com"
                     "Jeff Stephens"
                    "Jan 5, 2005"
                    ""
                    SF-IMAGE "Image" 0
                    SF-DRAWABLE "Drawable" 0
                    SF-ADJUSTMENT   _"Blur Radius" '(30 1 200 1 1 1 0 1)
                    SF-ADJUSTMENT _"Opacity" '(80 0 100 1 1 0 1)
)
