;;;
;;; precision-select.scm
;;;
;;;
;;; --------------------------------------------------------------------
;;; version 0.1  by Jeff Trefftzs <trefftzs@tcsn.net>
;;;     - Initial relase
;;; version 0.2 Raymond Ostertag <r.ostertag@caramail.com>
;;;     - ported to Gimp 2.0
;;;     - changed menu entry
;;; --------------------------------------------------------------------
;;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-precision-select inImage inLayer
				    inXorig inYorig
				    inWidth inHeight)

  (gimp-rect-select inImage 
		    inXorig inYorig
		    inWidth inHeight
		    CHANNEL-OP-REPLACE
		    FALSE		; No feathering
		    0)

  (gimp-displays-flush)
)

(script-fu-register
 "script-fu-precision-select"
 _"<Image>/Script-Fu/Selection/Precision Selection..."
 "Precision select carefully places a rectangular selection\
of the user-specified size at the user-specified coordinates.\
I decided this would be useful after trying for the nth time\
to select just the square front of a CD cover."
 "Jeff Trefftzs"
 "Copyright 2002, Jeff Trefftzs"
 "January 11, 2002"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X origin" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y origin" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Width" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Height" '(0 0 9999 1 10 0 1)
)
