; travel anim plugin
; Original version :
;   2000 MARIN Laetitia 
;   titix@amin.unice.fr
; Version 0.2 Raymond Ostertag 2004/09
;   - ported to gimp2
;   - changed menu entry

(define (create-radar img radar type angle)
  (if (> angle 0)
      (begin 
	(let ((copy (car (gimp-layer-copy radar TRUE))))
	  (gimp-image-add-layer img copy 0)
	  (plug-in-polar-coords TRUE img copy type angle 0 1 1) 
	  (create-radar img radar type (- angle 15))))))

(define (create-radar2 img radar type angle)
  (if (< angle 360)
      (begin 
	(let ((copy (car (gimp-layer-copy radar TRUE))))
	  (gimp-image-add-layer img copy 0)
	  (plug-in-polar-coords TRUE img copy type angle 0 1 1) 
	  (create-radar2 img radar type (+ angle 15))))))

(define (script-fu-radar-anim sens typ)
  (let* ((old-bg-color (car (gimp-palette-get-background)))
	 (old-fg-color (car (gimp-palette-get-foreground)))
	 (size 120)
	 (img (car (gimp-image-new size size RGB)))	 
	 (radar (car (gimp-layer-new img size size RGBA-IMAGE "radar" 100 NORMAL-MODE))))

    (gimp-image-undo-disable img)

    (gimp-image-add-layer img radar 0)

    ;; init layers
    (gimp-palette-set-foreground '(0 0 0))
    (gimp-edit-fill radar FOREGROUND-FILL)

    (plug-in-noisify TRUE img radar 1 0.26  0.26  0.26  0.26)
    (plug-in-autostretch-hsv TRUE img radar)
    ;(gimp-desaturate radar)
    (plug-in-mblur TRUE img radar 0 256 0)
    (plug-in-mblur TRUE img radar 0 256 0)
    (plug-in-mblur TRUE img radar 0 256 0)
    (plug-in-mblur TRUE img radar 0 256 0)
    (plug-in-mblur TRUE img radar 0 256 0)

    ;; copy current image
    (gimp-selection-all img)
    (gimp-edit-copy radar)

    (let ((create (if (= sens 0)
		      (lambda (img radar percent) 
			(create-radar img radar percent 360))
		      (lambda (img radar percent) 
			(create-radar2 img radar percent 0)))))      
      (if (= typ 1)
	  (create img radar 0)
	  (create img radar 100)))

    (gimp-image-remove-layer img radar)
      
    (gimp-selection-none img)
   
    (gimp-palette-set-foreground old-fg-color)
    (gimp-palette-set-background old-bg-color)

    (gimp-image-undo-enable img)

    (gimp-display-new img)))


(script-fu-register "script-fu-radar-anim"
		    "<Toolbox>/Xtns/Script-Fu/Animation/Radar..."
		    "make a radar anim"
		    "MARIN Laetitia"
		    "MARIN Laetitia"
		    "Fev 2000"
		    ""
		    SF-TOGGLE "from right to left" 0
		    SF-TOGGLE "square" 0)


