; skinnable plugin
;
; Original version :
;   2000 MARIN Laetitia 
;   titix@amin.unice.fr
; Version 0.1a Raymond Ostertag 2004/09
;   - changed menu entry

(define (decal nb-layers layers-array size decal-size)
  (if (> nb-layers 0)
      (begin 
	(gimp-layer-translate (aref layers-array (- nb-layers 1)) decal-size 0)
	(decal (- nb-layers 1) layers-array size (+ decal-size size)))))
      
(define (script-fu-skinnable-from-anim img drawable)
  (let* ((old-bg-color (car (gimp-palette-get-background)))
	 (old-fg-color (car (gimp-palette-get-foreground)))
	 (sizeX (car (gimp-image-width img)))
	 (sizeY (car (gimp-image-height img))))

    (gimp-image-undo-disable img)

    (let* ((layers (gimp-image-get-layers img))
	  (nb-layers (car layers))
	  (layers-array (cadr layers)))
      (gimp-image-resize img (* sizeX nb-layers) sizeY 0 0) 
      (decal nb-layers layers-array sizeX 0))

    (gimp-palette-set-foreground old-fg-color)
    (gimp-palette-set-background old-bg-color)

    (gimp-image-undo-enable img)


    (gimp-displays-flush)))

(script-fu-register "script-fu-skinnable-from-anim"
		    "<Image>/Script-Fu/Utils/Make band from animation"		    
		    "sprite band creation from an animation"
		    "MARIN Laetitia"
		    "MARIN Laetitia"
		    "Fev 2000"
		    ""
		    SF-IMAGE "Image to stamp" 0
		    SF-DRAWABLE "Drawable to stamp" 0)


