; firework spray anim script
; 
; Original version :
;   2000 MARIN Laetitia 
;   titix@amin.unice.fr
; Version 0.1 Raymond Ostertag 2004/09
;   - Ported to Gimp2
;   - Changed menu entry

(define (script-fu-spray c1 c2)
  (let* ((old-bg-color (car (gimp-palette-get-background)))
	 (old-fg-color (car (gimp-palette-get-foreground)))
	 (sizeX 256)
	 (sizeY 256)
	 (img (car (gimp-image-new sizeX sizeY RGB)))	 
	 (spray1 
	  (car 
	   (gimp-layer-new img sizeX sizeY RGBA-IMAGE "spray1" 100 NORMAL-MODE)))
	 (spray2
	  (car 
	   (gimp-layer-new img sizeX sizeY RGBA-IMAGE "spray2" 100 NORMAL-MODE))))

    (gimp-image-add-layer img spray1 0)
    (gimp-image-add-layer img spray2 0)

    (gimp-palette-set-background '(255 255 255))
    (gimp-edit-fill spray1 BACKGROUND-FILL)    
    (gimp-edit-clear spray2)

    (plug-in-grid TRUE img spray1 
		  1 32 8 c1 255    
		  0 32 8 c1 255    
		  0  2 6 c1 255)

    (plug-in-grid TRUE img spray2 
		  1 32 24 c2 255    
		  0 32 24 c2 255    
		  0  2 6 c2 255)

    (plug-in-polar-coords TRUE img spray1 0 0 0 1 1)
    (plug-in-polar-coords TRUE img spray2 0 0 0 1 1)

    (gimp-ellipse-select img 0 0 sizeX sizeY 2 TRUE  0 0)
    (gimp-selection-shrink img 20) 
    (gimp-selection-invert img) 
    (gimp-edit-fill spray1 BACKGROUND-FILL) 

    (gimp-ellipse-select img 0 0 sizeX sizeY 2 TRUE  0 0)
    (gimp-selection-shrink img 35) 
    (gimp-selection-invert img) 
    (gimp-edit-cut spray2) 

    (gimp-ellipse-select img 0 0 sizeX sizeY 2 TRUE  0 0)
    (gimp-selection-shrink img 40) 
    (gimp-selection-border img 10)
    (gimp-edit-fill spray1 BACKGROUND-FILL) 

    (gimp-ellipse-select img 0 0 sizeX sizeY 2 TRUE  0 0)
    (gimp-selection-shrink img 60) 
    (gimp-selection-border img 10)
    (gimp-edit-cut spray2) 
    
    (let* ((lay (car (gimp-image-flatten img)))
	   (lay2 (car (gimp-layer-copy lay 1)))
	   (lay3 (car (gimp-layer-copy lay 1)))
	   (lay4 (car (gimp-layer-copy lay 1))))
      (gimp-image-add-layer img lay2 0)
      (gimp-image-add-layer img lay3 0)
      (gimp-image-add-layer img lay4 0)
      (plug-in-whirl-pinch TRUE img lay2 0 0.4 1)
      (plug-in-whirl-pinch TRUE img lay3 0 0.8 1)
      (plug-in-whirl-pinch TRUE img lay4 0 0.4 1))

    (gimp-palette-set-foreground old-fg-color)
    (gimp-palette-set-background old-bg-color)
    
    (gimp-display-new img)))

(script-fu-register "script-fu-spray"
		    "<Toolbox>/Xtns/Script-Fu/Animation/Spray..."
		    "make a firework spray animation"
		    "MARIN Laetitia"
		    "MARIN Laetitia"
		    "Jun 2001"
		    ""
		    SF-COLOR _"color 1 to use"  '(1 36 129)
		    SF-COLOR _"color 2 to use"  '(30 71 200))

