;; move-layer.scm
;; Dialog box for the gimp-layer-translate procedure.
;;
;; Original version
;;   Author: Arch. Giuseppe Conte  <http://space.tin.it/edicola/lwcon>
;; Version 0.2
;;   Raymond Ostertag 2004/09
;;   - Changed menu entry
;;
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-move-layer image layer offsetx offsety)

 	(set! activelayer (car (gimp-image-get-active-layer image)))
 
    	(gimp-layer-translate activelayer offsetx offsety)
    	
    	(gimp-displays-flush)

    )



(script-fu-register "script-fu-move-layer"
		    "<Image>/Script-Fu/Utils/Move layer..."
		    "Dialog box for the gimp-layer-translate procedure. Move the active layer from the current position by the amount specified in the x and y offset, these can be negative or positive"
		    "Arch. Giuseppe Conte (http://space.tin.it/edicola/lwcon/)"
		    "Giuseppe Conte"
		    "2003/08/13"
		    ""
		    SF-IMAGE "Image" 0
		    SF-DRAWABLE "Drawable" 0
 		    SF-ADJUSTMENT "Offset x" '(0 -9999 9999 1 10 0 1)		    
 		    SF-ADJUSTMENT "Offset y" '(0 -9999 9999 1 10 0 1)
		    )

























